/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.sso.interceptors;//package cn.sagacloud.server.adm.interceptors

//
//import com.sagacloud.admin.entity.User;
//import com.sagacloud.admin.model.UserModel;
//import com.sagacloud.admin.repository.UserRepository;
//import com.sagacloud.common.json.JsonMapper;
//import com.sagacloud.common.web.MapResponse;
//import com.sagacloud.common.web.ServletUtils;
//import com.sagacloud.feign.SSOServiceClient;
//import org.apache.shiro.SecurityUtils;
//import org.apache.shiro.authc.UsernamePasswordToken;
//import org.apache.shiro.subject.Subject;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;
//
//import javax.servlet.http.HttpServletRequest;
//import javax.servlet.http.HttpServletResponse;
//
//class SessionInterceptor : HandlerInterceptorAdapter {
//
//    final Logger logger = LoggerFactory.getLogger(SessionInterceptor.class);
//
//    @Autowired
//    private SSOServiceClient ssoServiceClient;
//
//    @Autowired
//    private UserRepository userRepository;
//
//    @Override
//    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
//        logger.info("开始请求地址拦截");
//        ServletUtils.showHeaders(request);
//        ServletUtils.showCookies(request);
//        String token = request.getHeader("sso-token");
//
//        if (token == null) {
//            ServletUtils.writeJson(response, "{\"result\":\"unauthc\",\"message\":\"no token\"}");
//            return false;
//        }
//
//        try {
//            Subject subject = SecurityUtils.getSubject();
//            if (subject.isAuthenticated()) {
//                Object principal = subject.getPrincipal();
//                if (principal instanceof UserModel) {
//                    // 防止前端切换用户, 用token做密码
//                    UserModel userModel = (UserModel) principal;
//                    if (!userModel.getToken().equalsIgnoreCase(token)) {
//                        return checkToken(subject, token, response);
//                    }
//                } else {
//                    return checkToken(subject, token, response);
//                }
//            } else {
//                return checkToken(subject, token, response);
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            logger.error("login check error: {}", e);
//            return false;
//        }
//        return true;
//    }
//
//    private boolean checkToken(Subject subject, String token, HttpServletResponse response) {
//        MapResponse resp = ssoServiceClient.tokenCheck(token);
//        logger.info("token check resp: {}", JsonMapper.toSimpleJson(resp));
//        if (!resp.success()) {
//            logger.error("go to login");
//            ServletUtils.writeJson(response, JsonMapper.toSimpleJson(resp));
//            return false;
//        }
//
//        Integer userId = resp.getInteger("id");
//        User user = userRepository.findOne(userId);
//
//        if (user == null) {
//            // 用户不存在
//            ServletUtils.writeJson(response, "{\"result\": \"nouser\"}");
//            return false;
//        } else {
//            UsernamePasswordToken shiroToken = new UsernamePasswordToken(user.getName(), token);
//            subject.login(shiroToken);
//        }
//        return true;
//    }
//
//}
